import processing.serial.*;
Serial myPort;

int v,v0;
int xpos;
int screen_height,screen_width;
PFont font;
String lines[];

void setup(){
  lines = loadStrings("settings.txt"); 
  myPort=new Serial(this,lines[0],57600);
  
  screen_width=int(lines[1]);
  screen_height=int(lines[2]);
  size(screen_width,screen_height);
  xpos=0;
  
  font = loadFont("AgencyFB-Reg-24.vlw");
  redraw();
}

void draw(){
  //st=millis()/1000;
}

void redraw(){
  background(255);
  stroke(255, 100, 100); 
  textFont(font,24);
  fill(0, 102, 153);
  text("ArduChartECG", 10, 30); 
  text(lines[0], 10, 60); 
}

void serialEvent(Serial p){
  if(myPort.available()>1){
    v0=v;
    int v_high = myPort.read();
    int v_low = myPort.read(); 
    v = v_high * 256 + v_low;
    v=v/2;
    
    line(xpos-1,screen_height-v0,xpos,screen_height-v);
    xpos++;
    if(xpos>screen_width){xpos=0;redraw();}
  } 
}
