import processing.serial.*;
Serial myPort;

int v,v0;
int r;
int xpos;
int screen_height,screen_width;
PFont font;
String lines[];
long t,t0,st,st0;
int IBI;
float HR;
String Data[];
int dcnt=0;

void setup(){
  lines = loadStrings("settings.txt"); 
  myPort=new Serial(this,lines[0],9600);
  
  screen_width=int(lines[1]);
  screen_height=int(lines[2]);
  size(screen_width,screen_height);
  xpos=0;
  
  font = loadFont("AgencyFB-Reg-24.vlw");
  redraw();
  t=0;t0=0;
  Data=new String[3600];
}

void draw(){
  
  st=millis()/1000;
  if(st!=st0){
    String str;
    str=IBI+","+HR;
    Data[dcnt]=str;
    //saveStrings("result.csv", Data); 
    st0=st;
    dcnt++;       

    stroke(255, 255, 255); 
    fill(255, 255, 255); 
    rect(0, 60, 100, 30);
    textFont(font,24);
    fill(0, 102, 153);
    text(dcnt, 10, 90);
    stroke(255, 100, 100); 
    
    if(dcnt%10==0){
      str=" , ";
      Data[dcnt]=str;
      saveStrings("result.csv", Data);
    }
  }
  
}

void redraw(){
  background(255);
  stroke(255, 100, 100); 
  textFont(font,24);
  fill(0, 102, 153);
  text("ArduChartIBI", 10, 30); 
  text(lines[0], 10, 60); 
  
  text("500ms", 10, screen_height-250); 
  line(0,screen_height-250,screen_width,screen_height-250);
  text("1000ms", 10, screen_height-500); 
  line(0,screen_height-500,screen_width,screen_height-500);
}

void serialEvent(Serial p){
  if(myPort.available()>1){
    v0=v;
    int v_high = myPort.read();
    int v_low = myPort.read(); 
    v = v_high * 256 + v_low;
    v=v/2;
    IBI=v*2;
    //HR=60000/IBI;    
    HR=(float)60000/(float)IBI;
    
    line(xpos-1,screen_height-v0,xpos,screen_height-v);
    xpos++;
    
    if(xpos>screen_width){xpos=0;redraw();}
  } 
}
